module PeppersGhost::GhostFactory
  def define(&block)
    instance_eval &block
  end

  def ghost_for(resource)
    ghosts[resource]
  end

  def ghost(name, &block)
    ghost = PeppersGhost::Ghost.new
    ghost.instance_eval &block
    ghosts[name] = ghost
  end

  private

  def ghosts
    @ghosts ||= {}
  end
end
