module PeppersGhost::Matchers
  matcher :match_structure_of do |expected|
    chain :with do |count|
      @count = count
    end

    match do |actual|
      begin
        resource = PeppersGhost.ghost_for(expected)
        match_structure actual, resource.attributes, @count, @method
      rescue RSpec::Expectations::ExpectationNotMetError => e
        @error = e.message
        false
      end
    end

    failure_message_for_should do
      @error
    end

    def method_missing(method, *args, &block)
      if defined?(@method)
        super
      else
        @method = method
      end
      self
    end
  end
end
